<?php
//*******************************************************************
//
//  Creation d'un compte Chat
//
// Projet      : Chaton
// Version     : 1.6.3
// Date        : 8 avril 2007
//
//*******************************************************************

    // Inclus generaux
    require_once( "inc/chat.php");
    require_once( "inc/securite.php");
    require_once( "inc/langue.php");
    require_once( "inc/env.php");
    require_once( "inc/database.php");
    require_once( "inc/log.php");
    require_once( "inc/users.php");
    require_once( "inc/html.php");
    require_once( "inc/cryptage.php");
    require_once( "inc/fuseaux.php");
    require_once( "inc/nocache.php");

    // Charge le module de langue associ au script courant
    if (file_exists( "lang/$lang/creation.php")) {
        include( "lang/$lang/creation.php");
    }

    chat_open();

    $affiche = false;

    // S'il a rentre des donnees
    if (isset( $datas)) {
        if (checkdate( $naissance_mois, $naissance_jour, $naissance_annee) == false) {
            $naissance_mois = 0;
            $naissance_jour = 0;
            $naissance_annee = 0;
            $naissance = "";
        } else {
            $naissance = "$naissance_annee-$naissance_mois-$naissance_jour";
        }
        // Verification des donnees
        if ($login and $mdp1 and $mdp2 and $nom and $prenom and $sexe) {
            // Met en forme le login
            $login = strtolower( $login);
            if (strspn( $login, "abcdefghijklmnopqrstuvwxyz0123456789.ABCDEFGHIJKLMNOPQRSTUVWXYZ") == strlen( $login)) {
                $mdp1 = ValideMdp( $mdp1);
                $mdp2 = ValideMdp( $mdp2);
                if ($mdp1 and $mdp2) {
                    if ($mdp1 == $mdp2) {
                        if (strrpos($mdp1,"'") === false) {
                            $mdp = Encrypte( $mdp1);
                            // Verifie que l'utilisateur n'existe pas deja
                            $requete = mysql_query( "SELECT login FROM $table_base_utilisateur WHERE login='$login'");
                            if ($requete) {
                                if (mysql_num_rows( $requete) == 0) {
                                    $requete = mysql_query( "INSERT INTO $table_base_utilisateur (login,mdp_encoded,nom,prenom,email,pays,fuseau,bio,nom_site,url_site,sexe,naissance,priv,creation) VALUES ('$login',ENCODE('$mdp','" . PASS_MYSQL . "'),'$nom','$prenom','$email','$pays','$fuseau','$bio','$nom_site','$url_site','$sexe','$naissance','1',now())");
                                    if ($requete) {
                                        // La suite !
                                        header( "Location: creationok.php?login=" . urlencode( $login) . "&lang=$lang");
                                        exit();
                                    } else {
                                        $affiche = true;
                                        $message = $langue["erreur_base"];
                                    }
                                } else {
                                    $affiche = true;
                                    $login = "";
                                    $message = $langue["erreur_dejapris"];
                                }
                            } else {
                                $affiche = true;
                                $message = $langue["erreur_base"];
                            }
                        } else {
                            $affiche = true;
                            $message = $langue["erreur_mdp_incorrect"];
                        }
                    } else {
                        $affiche = true;
                        $message = $langue["erreur_mdp"];
                    }
                } else {
                    $affiche = true;
                    $message = $langue["erreur_mdp_incorrect"];
                }
            } else {
                $affiche = true;
                $message = $langue["erreur_login"];
            }
        } else {
            $affiche = true;
            $message = $langue["erreur_saisie"];
        }
    } else
        // Il n'a pas rentre de donnees
        $affiche = true;

    if ($affiche) {
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title><?php echo( $langue["titre"]); ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo( CHARSET); ?>">
<link rel="stylesheet" href="<?php echo( TEMPLATE_DIR . TEMPLATE . '/'); ?>css/style.css" type="text/css">
</head>

<body bgcolor="#FFFFFF">
<fieldset>
<legend><?php echo( $langue["titre"]); ?></legend>
<table border="0" align="center" cellpadding="1" cellspacing="0">
  <tr>
    <td colspan="3" align="center"><?php echo( $langue["inscription"]); ?></td>
  </tr>
  <tr>
    <td colspan="3">&nbsp;</td>
  </tr>
  <form method="post" action="creation.php">
    <input type="hidden" name="datas" value="1">
    <input type="hidden" name="lang" value="<?php echo( $lang); ?>">
    <?php
            if (isset( $message)) {
?>
    <tr>
      <td colspan="3" align="center"><font color="#DD0000"><b> <?php echo( $message); ?>
        </b></font></td>
    </tr>
    <tr>
      <td colspan="3">&nbsp;</td>
    </tr>
    <?php
            }
?>
    <tr>
      <td>
        <?php if (isset($datas) and !$nom) { ?>
        <font color="#DD0000">*</font>
        <?php } ?>
      </td>
      <td> &nbsp;<?php echo( $langue["nom"]); ?> :</td>
      <td> <input type="text" name="nom" size="30" maxlength="30"<?php if (isset($nom)) echo(" value=\"$nom\""); ?>>
      </td>
    </tr>
    <tr>
      <td>
        <?php if (isset($datas) and !$prenom) { ?>
        <font color="#DD0000">*</font>
        <?php } ?>
      </td>
      <td> &nbsp;<?php echo( $langue["prenom"]); ?> :</td>
      <td> <input type="text" name="prenom" size="30" maxlength="30"<?php if (isset($prenom)) echo(" value=\"$prenom\""); ?>>
      </td>
    </tr>
    <tr>
      <td>
        <?php if (isset($datas) and !$login) { ?>
        <font color="#DD0000">*</font>
        <?php } ?>
      </td>
      <td> &nbsp;<?php echo( $langue["login"]); ?> : </td>
      <td> <input type="text" name="login" size="30" maxlength="30"<?php if (isset($login)) echo(" value=\"$login\""); ?>>
      </td>
    </tr>
    <tr>
      <td>
        <?php if (isset($datas) and !$mdp1) { ?>
        <font color="#CC0033">*</font>
        <?php } ?>
      </td>
      <td> &nbsp;<?php echo( $langue["mdp1"]); ?> :</td>
      <td> <input type="password" name="mdp1" size="20" maxlength="20"<?php if (isset($mdp1)) echo(" value=\"$mdp1\""); ?>>
      </td>
    </tr>
    <tr>
      <td>
        <?php if (isset($datas) and !$mdp2) { ?>
        <font color="#DD0000">*</font>
        <?php } ?>
      </td>
      <td> &nbsp;<?php echo( $langue["mdp2"]); ?> :</td>
      <td> <input type="password" name="mdp2" size="20" maxlength="20"<?php if (isset($mdp2)) echo(" value=\"$mdp2\""); ?>>
      </td>
    </tr>
    <tr>
      <td> <?php if (isset($datas) and (!isset($sexe) or ($sexe == 0)) ) { ?>
        <font color="#DD0000">*</font>
        <?php } ?> </td>
      <td> &nbsp;<?php echo( $langue["sexe"]); ?> :</td>
      <td> <input type="radio" name="sexe" value="1"<?php if (isset($sexe) and ($sexe == 1)) echo( " checked"); ?>>
        <?php echo( $langue["homme"]); ?> <input type="radio" name="sexe" value="2"<?php if (isset($sexe) and ($sexe == 2)) echo( " checked"); ?>>
        <?php echo( $langue["femme"]); ?></td>
    </tr>
    <tr>
      <td> </td>
      <td> &nbsp;<?php echo( $langue["naissance"]); ?> :</td>
      <td> <select name="naissance_jour">
          <?php
    for ($i=1; $i<=31; $i++) {
        echo( "          <option value=\"$i\"");
        if (isset($naissance_jour) and ($naissance_jour == $i)) echo( " selected");
        echo( ">$i</option>\n");
    }
?>
        </select> &nbsp; <select name="naissance_mois">
          <?php
    for ($i=1; $i<=12; $i++) {
        echo( "          <option value=\"$i\"");
        if (isset($naissance_mois) and ($naissance_mois == $i)) echo( " selected");
        echo( ">" . $tableaumois[$i] . "</option>\n");
    }
?>
        </select> &nbsp; <select name="naissance_annee">
          <?php
    for ($i=1900; $i<=2000; $i++) {
        echo( "          <option value=\"$i\"");
        if (isset($naissance_annee) and ($naissance_annee == $i)) echo( " selected");
        echo( ">$i</option>\n");
    }
?>
        </select> </td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td> &nbsp;<?php echo( $langue["email"]); ?> :</td>
      <td> <input type="text" name="email" size="30" maxlength="60"<?php if (isset($email)) echo(" value=\"$email\""); ?>>
      </td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><?php echo( $langue["pays"]); ?>
        :</td>
      <td><input type="text" size="30" name="pays"<?php if (isset($pays)) echo(" value=\"$pays\""); ?>></td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><?php echo( $langue["fuseau"]); ?>
        :</td>
      <td><select name="fuseau">
      <?php    foreach( $fuseaux_horaires as $cle => $valeur) {
                echo( "<option value=\"$cle\"");
                if (isset($fuseau) and ($cle == $fuseau)) echo( " selected");
                echo( ">" . htmlentities( $valeur[1]) . "</option>\n");
            }
      ?>
      </select></td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td valign="top"> &nbsp;<?php echo( $langue["bio"]); ?> :</td>
      <td><textarea name="bio" cols="50" rows="5" id="bio"><?php if (isset($bio)) echo($bio); ?></textarea></td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td> &nbsp;<?php echo( $langue["nom_site"]); ?> :</td>
      <td><input name="nom_site" type="text" id="nom_site" size="30" maxlength="60"<?php if (isset($nom_site)) echo(" value=\"$nom_site\""); ?>></td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td> &nbsp;<?php echo( $langue["url_site"]); ?> :</td>
      <td><input name="url_site" type="text" id="url_site" size="30" maxlength="60"<?php if (isset($url_site)) echo(" value=\"$url_site\""); ?>></td>
    </tr>
    <tr>
      <td colspan="3">&nbsp;</td>
    </tr>
    <tr>
      <td colspan="3" align="center"> <input type="submit" name="creer_compte" value="<?php echo( $langue["valider"]); ?>">
      </td>
    </tr>
    <tr>
      <td colspan="3">&nbsp;</td>
    </tr>
  </form>
</table>
</fieldset>
<?php
    }
    chat_close();
?>
</body>
</html>