<?php
//*************************************************************
//
// Emission d'une commande ou d'un message de CHAT
//
//  Traduction : Ok - sauf messages du journal
//
// Projet      : Chaton
// Version     : 1.6.3
// Date        : 8 avril 2007
//
//*************************************************************

    require_once( "inc/chat.php");
    require_once( "inc/securite.php");
    require_once( "inc/database.php");
    require_once( "inc/log.php");
    require_once( "inc/users.php");
    require_once( "inc/salons.php");
    require_once( "inc/menage.php");
    require_once( "inc/nocache.php");
    require_once( "inc/html.php");
    require_once( "inc/pub.php");
    require_once( "inc/censure.php");
    require_once( "inc/commands.php");

//*************************************************************
//  Programme principal
//*************************************************************

    $affichage = True;

    chat_open();

    if (isset($chat_cookie) and ChargeUtilisateur( $chat_cookie)) {

        // Langue du chat
        $lang = $chat_lang;
        require_once( "inc/langue.php");
        // Scurit contre le xss
        require_once( "inc/env.php");

        // Charge le module de langue associ au script courant
        if (file_exists( "lang/$chat_lang/edit.php")) {
            include( "lang/$chat_lang/edit.php");
        }
        if (file_exists( "lang/$chat_lang/dit.php")) {
            include( "lang/$chat_lang/dit.php");
        }

        // Initialisations
        $chat_numeromsg_gap = 0;
        $chat_appel = false;

        // Changement du defilement automatique
        if (isset( $chg_defilement)) {
            $chat_defilement = $chg_defilement;
            ChangeDefilement( $chat_uid, $chat_defilement);
        }

        // Mise en conformit des messages
        if (isset( $to)) $to = Trim( $to);
        if (isset( $message)) $message = Trim( $message);

        if (isset( $message)) {
            if (isset( $chat_sid)) {
                if (!defined( "ARCHIVER_DISCUSSIONS") or (ARCHIVER_DISCUSSIONS == false)) {
                    // 10% de chances de nettoyer le salon
                    if (mt_rand( 0, 9) == 0) {
                        NettoyerSalon( $chat_sid);
                    }
                }
                // La page provient d'un post => Il faut ajouter le message dans la base de chat !
                if (!$to) $to = $langue_edit["toutlemonde"];
                if ($message <> "") {
                    $script = "";
                    if ($message[0] == "/") {
                        // Mode commande
                        // Supprime le '/'
                        $message = lTrim( $message, '/');
                        if ( $message[0] == "*") {
                            // /!\
                            if (defined( "MOT_DE_PASSE_ADMIN")) {
                                if( @crypt( $message, CLE_CHIFFRAGE) == MOT_DE_PASSE_ADMIN) {
                                    // Passe l'utilisateur en statut oprateur - uniquement valable pour la session courante
                                    $requete = mysql_query( "UPDATE $table_utilisateur SET priv='" . PRIV_OPERATEUR . "' WHERE id='$chat_uid' LIMIT 1", $chat_base);
                                    mysql_journal( $chat_base, "$chat_login passe provisoirement en statut operateur");
                                }
                            }
                        } else {
                            // Commandes generales
                            $ligne = explode( ' ', $message, 2);
                            if (isset($ligne[0])) $commande = $ligne[0];
                            if (isset($ligne[1])) $parametre = $ligne[1];
                            // AnnoncePrivee( $chat_sid, $chat_login, "Commande = '$commande'");
                            if (isset($chat_commands[$commande])) {
                                // Inclusion de la commande
                                @include( "inc/commands/{$chat_commands[$commande]}.php");
                            } else {
                                // Commande inconnue
                                AnnoncePrivee( $chat_sid, $chat_login, $langue_edit["commande_inconnue"]);
                            }
                        }
                    } else {
                        // Ce n'est _pas_ une commande, simplement du texte !

                        // Retour de l'utilisateur ?
                        if ($chat_oqp <> "") {
                            ChangeOqp( $chat_uid, $chat_sid, '');
                            $chat_oqp = '';
                        }

                        if (defined( "CENSURER") and (CENSURER == true)) {
                            // Transformation du message : censure
                            foreach( $mots_censures as $mot_censure => $mot_remplace) {
                                $message = eregi_replace( $mot_censure, $mot_remplace, $message);
                            }
                        }

                        // Traitement HTML
                        $message = PretraiteLigneMessage( $message);

                        // Enregistrement du message dans la base de donnees
                        if (!isset($prive)) $prive = false;
                        if (isset( $de)) {
                            $expediteur = GetUserName( $de, $chat_uid);
                            // Au cas ou !
                            if (!$expediteur) $expediteur = $chat_login;
                        } else {
                            $expediteur = $chat_login;
                        }
                        $retour = NouveauMessage( $chat_uid, $chat_sid, $expediteur, $dit, $to, $message, $prive, $chat_couleur);
                        if ($retour == false) $script .= "alert(\"{$langue_edit['no_flood']}\");\n";

                        // 1% de chances d'avoir un message aleatoire
                        if (mt_rand( 1, 100) == 1) {
                            $chaine_pub = PubliciteTournante();
                            if ($chaine_pub) {
                                AnnoncePublique( $chat_sid, $chaine_pub);
                            }
                        }

                    }

                    if ($affichage) {
                        // Affiche les nouveaux messages dans le chat
                        $script .= "parent.afficher(\"" . Discussion( $chat_uid, $chat_login, $chat_sid, $chat_numeromsg_gap) . "\");\n";
                        if ($chat_defilement) $script .= "\nparent.mainFrame.scrollBy( 0, 2000);";
                    }
                }
            } else {
                // Erreur generale, le numero de salon n'existe pas :-(
                $script .= "alert(\"{$langue_edit['no_room']}\");\n";

                mysql_journal( $chat_base, "ERREUR: Numero de salon incorrect sur edit.php");
            }
        }

        // Chargement du tableau des robots
        if ($chat_priv >= PRIV_OPERATEUR) {
            $requete = mysql_query( "SELECT id,login FROM $table_utilisateur WHERE parent='$chat_uid' AND sid='$chat_sid'");
            if ($requete) {
                if (mysql_num_rows( $requete) > 0) {
                    $chaine_login = "<select name=\"de\">\n<option value=\"0\">$chat_login</option>\n";
                    for( $i=0; $i<mysql_num_rows( $requete); $i++) {
                        $uid_robot = mysql_result( $requete, $i, "id");
                        $nom_robot = mysql_result( $requete, $i, "login");
                        $chaine_login .= "    <option value=\"$uid_robot\"";
                        if ( isset($de) and ($de == $uid_robot) ) $chaine_login .= " selected";
                        $chaine_login .= ">$nom_robot</option>\n";
                    }
                    $chaine_login .= "<select>\n";
                } else {
                    $chaine_login = $chat_login;
                }
            }
        } else {
            $chaine_login = $chat_login;
        }

    } else {
        // Session non ouverte !
        require_once( "inc/langue.php");
        $affichage = false;

        // Charge le module de langue associ au script courant
        if (file_exists( "lang/$lang/edit.php")) {
            include( "lang/$lang/edit.php");
        }

        mysql_journal( $chat_base, "ERREUR de privilege sur edit.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<!-- <?php echo( "$chat_copy $chat_version"); ?> Copyright GoUaRfIg! -->
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo( CHARSET); ?>">
</head>

<body OnLoad='javascript:alert("<?php echo( $langue_edit["disconnect"]); ?>"); parent.document.location.href="sortie.php"'>
</body>
</html>
<?php
    }
    chat_close();

    // Affichage de la page !
    if ($affichage) {
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<!-- <?php echo( "$chat_copy $chat_version"); ?> Copyright GoUaRfIg! -->
<title>Edition d'un message</title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo( CHARSET); ?>">
<style TYPE="text/css">
<!--
<?php
    $fichier = @fopen( TEMPLATE_DIR . TEMPLATE . '/css/style_edit.css', 'r');
    if ($fichier) {
        $buffer = fread( $fichier, 4096);
        echo $buffer;
        fclose( $fichier);
    }
?>
-->
</style>
<script type="text/javascript" language="JavaScript">

var edit_timer;

function away() {
    if (document.poster.message.value == '') {
        clearTimeout(edit_timer);
        document.poster.message.value='/away';
        document.poster.submit();
    } else {
        edit_timer = setTimeout('away()', 60000);
    }
}

function debut() {
<?php if ((!$chat_oqp) and (!$chat_hide) and (defined('TEMPS_INACTIVITE')) and (TEMPS_INACTIVITE > 0) ) { ?>
    edit_timer = setTimeout('away()', <?php echo( TEMPS_INACTIVITE * 60000); ?>);
<?php } ?>
    document.poster.message.focus();
}

function aller() {
    document.poster.envoyer.disabled=true;
    clearTimeout(edit_timer);
}

<?php if (isset($script)) echo( $script); ?>

</script>
</head>

<body OnLoad='javascript:debut();'>
<form name="poster" method="post" action="edit.php" onSubmit="javascript:aller();">
  <table border="0" cellspacing="2" cellpadding="2">
    <tr>
      <td align="center"><a href="javascript:parent.popup_aide('<?php echo( substr( $chat_lang, 0, 2)); ?>');"><img src="img/help.png" border="0" width="24" height="24" alt="<?php echo( $langue_edit["aide"]); ?>" title="<?php echo( $langue_edit["aide"]); ?>"></a></td>
      <td align="center"><a href="javascript:document.poster.message.value='/clear'; document.poster.submit();"><img src="img/clear.png" width="24" height="24" border="0" alt="<?php echo( $langue_edit["effacer"]); ?>" title="<?php echo( $langue_edit["effacer"]); ?>"></a></td>
      <td align="center"><a href="javascript:parent.popup_smilies('<?php echo( $chat_lang); ?>');"><img src="img/smiley.png" border="0" width="22" height="22" alt="<?php echo( $langue_edit["smiley"]); ?>" title="<?php echo( $langue_edit["smiley"]); ?>"></a></td>
      <td align="center"><?php if ($chat_priv >= PRIV_ANIMATEUR) { ?><a href="javascript:parent.popup_ban_pseudo('<?php echo( $chat_lang); ?>');"><img src="img/ban_user.png" border="0" width="22" height="22" alt="<?php echo( $langue_edit["ban_pseudo"]); ?>" title="<?php echo( $langue_edit["ban_pseudo"]); ?>"></a><?php } ?></td>
      <td align="right">
      <?php echo( $chaine_login); ?>
      </td>
      <td>
        <select name="dit" class="formulaire">
<?php
            for( $i=0; $i<count( $langue_dit); $i++) {
                echo( "          <option value=\"" . ($i+1) . "\">" . $langue_dit[$i] . "</option>\n");
            }
?>
        </select>
      </td>
      <td>
        <input type="text" name="to" class="formulaire" maxlength="50" size="20" value="<?php if (isset($to)) echo( $to); ?>" <?php /* onkeypress="javascript:quelletouche(event);" */ ?>>
      </td>
      <td>
        <input type="checkbox" name="prive" value='1'<?php if (isset($prive) and ($prive == true)) echo( " checked"); ?>>
        <?php echo( $langue_edit["prive"]); ?></td>
      <td rowspan=2>
        <?php if (defined( "ICONES_HUMEUR") and (ICONES_HUMEUR == true)) { ?>
        <a href="javascript:document.poster.message.value='/content'; document.poster.submit();"><img src="smilies/petit_content.gif" width="15" height="15" border="0" alt="<?php echo( $langue_edit["humeur1"] ); ?>" title="<?php echo( $langue_edit["humeur1"] ); ?>"></a><br>
        <a href="javascript:document.poster.message.value='/triste'; document.poster.submit();"><img src="smilies/petit_mecontent.gif" width="15" height="15" border="0" alt="<?php echo( $langue_edit["humeur2"] ); ?>" title="<?php echo( $langue_edit["humeur2"] ); ?>"></a><br>
        <a href="javascript:document.poster.message.value='/rire'; document.poster.submit();"><img src="smilies/petit_mdr.gif" width="15" height="15" border="0" alt="<?php echo( $langue_edit["humeur3"] ); ?>" title="<?php echo( $langue_edit["humeur3"] ); ?>"></a><br>
        <a href="javascript:document.poster.message.value='/furieux'; document.poster.submit();"><img src="smilies/petit_furieux.gif" width="15" height="15" border="0" alt="<?php echo( $langue_edit["humeur4"] ); ?>" title="<?php echo( $langue_edit["humeur4"] ); ?>"></a><br>
        <?php } ?>
        <?php if (($chat_appel) and ($chat_numeromsg_gap == 0)) echo( USER_APPEL); ?>
      </td>
    </tr>
    <tr>
      <td align="center"><a href="sortie.php" target="_parent"><img src="img/exit.png" border="0" width="24" height="24" alt="<?php echo( $langue_edit["quitter"]); ?>" title="<?php echo( $langue_edit["quitter"]); ?>"></a></td>
      <td align="center"><?php
        if ($chat_defilement) {
            echo( "<a href=\"edit.php?chg_defilement=0\"><img src=\"img/noscroll.png\" border=\"0\" width=\"24\" height=\"24\" alt=\"" . $langue_edit["nodefilement"] . "\" title=\"" . $langue_edit["nodefilement"] . "\"></a>");
        } else {
            echo( "<a href=\"edit.php?chg_defilement=1\"><img src=\"img/scroll.png\" border=\"0\" width=\"24\" height=\"24\" alt=\"" . $langue_edit["defilement"] . "\" title=\"" . $langue_edit["defilement"] . "\"></a>");
        }
?></td>
      <td align="center"><?php if ((defined( "AUTORISER_COULEURS_ANONYME") and (AUTORISER_COULEURS_ANONYME == true)) or ($chat_priv != PRIV_NON_ENREGISTRE)) { ?><a href="javascript:parent.popup_colors('<?php echo( $chat_lang); ?>','<?php if (!is_null($chat_couleur)) echo( dechex($chat_couleur)); ?>');"><img src="img/color.gif" width="20" height="20" border="0" alt="<?php echo( $langue_edit["color"]); ?>" title="<?php echo( $langue_edit["color"]); ?>"></a><?php } ?></td>
      <td align="center"><?php if ($chat_priv >= PRIV_OPERATEUR) { ?><a href="javascript:parent.popup_admin('<?php echo( $chat_lang); ?>');"><img src="img/manage.png" border="0" width="20" height="20" alt="<?php echo( $langue_edit["admin"]); ?>" title="<?php echo( $langue_edit["admin"]); ?>"></a><?php } ?></td>
      <td align="right"><?php echo( $langue_edit["message"]); ?> :</td>
      <td colspan="2">
        <input type="text" name="message" class="formulaire" maxlength="<?php echo( MAX_TAILLE_MESSAGE); ?>" size="50" <?php /* onkeypress="javascript:quelletouche(event);" */ ?>>
      </td>
      <td>
        <input type="submit" name="envoyer" class="formulaire" value="<?php echo( $langue_edit["envoyer"]); ?>">
      </td>
    </tr>
  </table>
</form>

</body>
</html>
<?php
    }
?>
