<?php
//*************************************************************
//
// Projet      : Chaton
// Auteur      : Frederic Quointeau
// Version     : 1.6.3
// Date        : 8 avril 2007
//
// Script d'installation ou de mise  jour version 1.6.3-1.3
//
//*************************************************************

define( "VERSION_MISE_A_JOUR", "1.6.3");

Function ValideChemin( $chemin) {
    if (strlen($chemin) > 0) {
        if ($chemin{strlen($chemin)-1} != '/') {
            $chemin .= '/';
        }
    }
    return $chemin;
}

    if (phpversion() < '4.1.0') {
        echo( "Vous devez disposer d'une version de PHP gale ou suprieure  la 4.1.0");
        exit();
    }

    if (!function_exists('mysql_connect')) {
        echo( "Vous devez disposer du support 'MySql' pour PHP. Consultez la documentation de PHP pour inclure ce module.");
        exit();
    }

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Installation ou mise &agrave; jour de Chaton</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="css/style.css" rel="stylesheet" type="text/css">
</head>

<body>
<br>
<?php
    if (isset($_POST["etape"])) {
        $etape = $_POST["etape"];
    } else {
        $etape = 0;
    }

    // Fichiers inclus
    include( "inc/copyr.php");

    if (file_exists( "inc/chat.php")) {
        include( "inc/chat.php");
    } elseif (file_exists( "inc/chat.inc")) {
        include( "inc/chat.inc");
    } else {
        include( "inc/chat.php-orig");
    }
    if (file_exists( "inc/database.php")) {
        include( "inc/database.php");
    } elseif (file_exists( "inc/database.inc")) {
        include( "inc/database.inc");
    } else {
        include( "inc/database.php-orig");
    }

    if (file_exists( "inc/externe.php")) {
        include( "inc/externe.php");
    }

    // Nouvelles constantes requises pour une mise  jour vers la 1.5.0 :
    if (!defined( 'TEMPLATE_DIR')) define( 'TEMPLATE_DIR', 'templates/');
    if (!defined( 'TEMPLATE_VERSION')) define( 'TEMPLATE_VERSION', '100');

    if ($etape == 0) {
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="1">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2" align="center"><strong>Bienvenue dans le script d'installation
        ou de mise &agrave; jour de Chaton v<?php echo( VERSION_MISE_A_JOUR); ?></strong> <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">
        Le lancement de ce script de configuration <strong>ne supprime pas vos
        &eacute;ventuels param&egrave;tres personnels (ant&eacute;rieurs)</strong> :<br><br>
        - Vous <strong>devez lancer ce script &agrave; chaque mise &agrave;
        jour</strong> de Chaton.<br>
        - Vous pouvez relancer ce script &agrave; volont&eacute;
        si vous voulez modifier la configuration de Chaton.<br>
        </td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2"><strong>Avant de d&eacute;marrer la proc&eacute;dure d'installation
        ou de mise &agrave; jour automatis&eacute;e :</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>- v&eacute;rifiez que vous avez acc&egrave;s en &eacute;criture par
        le serveur Web au dossier <strong>inc</strong> de Chaton. Au besoin donnez
        les droits d'&eacute;criture &agrave; tous utilisateurs sur le dossier
        par votre logiciel de transfert FTP. </td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>- munissez-vous de vos identifiants de connexion &agrave; votre base
        de donn&eacute;es MySQL (donn&eacute;s par votre h&eacute;bergeur)</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">Sans cel&agrave;, vous devrez configurer Chaton manuellement.</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2" align="right"><hr> <input type="submit" value="suivant &gt;&gt;">
      </td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
    } elseif ($etape == 1) {
        // Mise  jour vers une version 1.5.0 => Cration d'un template "personnel"
        if( !is_dir( TEMPLATE_DIR . 'personnel')) {
            // Le dossier n'existe pas, on va le crer
            if (@mkdir( TEMPLATE_DIR . 'personnel')) {
                // Copie des feuilles de style
                mkdir( TEMPLATE_DIR . 'personnel/css');
                if (is_dir( 'css')) copyr( 'css', TEMPLATE_DIR . 'personnel/css');
                // Header, footer et publicite
                @rename( 'header.php', TEMPLATE_DIR . 'personnel/header.php');
                @rename( 'footer.php', TEMPLATE_DIR . 'personnel/footer.php');
                @rename( 'publicite.txt', TEMPLATE_DIR . 'personnel/publicite.txt');
                // Censure
                // copy( 'inc/censure.php', TEMPLATE_DIR . 'personnel/censure.php');
                // Aide, Index, Help et Frame  partir du modle par dfaut
                copy( TEMPLATE_DIR . 'default/aide.php', TEMPLATE_DIR . 'personnel/aide.php');
                copy( TEMPLATE_DIR . 'default/help.php', TEMPLATE_DIR . 'personnel/help.php');
                copy( TEMPLATE_DIR . 'default/index.php', TEMPLATE_DIR . 'personnel/index.php');
                copy( TEMPLATE_DIR . 'default/frame.php', TEMPLATE_DIR . 'personnel/frame.php');
                // Config.php
                $fichier_config = fopen( TEMPLATE_DIR . 'personnel/config.php', 'w');
                if ($fichier_config) {
                    fwrite( $fichier_config,
"<?php
//*************************************************************
//
// Modle import  partir d'une version antrieure  la 1.5.0
//
// Modle      : personnel
// Version     : 1.0.0
//
//*************************************************************

    \$chat_model = array(
        'CUR_TEMPLATE_NAME' =>      'Modle personnel (import automatiquement)',
        'CUR_TEMPLATE_VERSION' =>   '100',
        // Largeur du tableau des utilisateurs
        'LARGEUR_BANDEAU_GAUCHE' => '" . (defined('LARGEUR_BANDEAU_GAUCHE') ? LARGEUR_BANDEAU_GAUCHE : '100%') . "',
        // Hauteur du bandeau haut
        'HAUTEUR_BANDEAU_HAUT' =>   '" . (defined('HAUTEUR_BANDEAU_HAUT') ? HAUTEUR_BANDEAU_HAUT : '35') . "',
        // Hauteur du bandeau du bas
        'HAUTEUR_BANDEAU_BAS' =>    '" . (defined('HAUTEUR_BANDEAU_BAS') ? HAUTEUR_BANDEAU_BAS : '30') . "',
    );

?>");
                    fclose( $fichier_config);
                }
            }
        }
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="2">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3" align="center"><strong>Script d'installation ou de mise
        &agrave; jour de Chaton (Etape 1)</strong> <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3"><strong>Qu'allez-vous utiliser comme mod&egrave;le d'apparence de Chaton ?</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Choix du mod&egrave;le :</td>
      <td><select name="modele" id="modele">
<?php
        if ($dh = @opendir( TEMPLATE_DIR)) {
            while (($file = readdir($dh)) !== false) {
                if ($file[0] != '.') {
                    // Test du modle
                    if (file_exists( TEMPLATE_DIR . $file . '/config.php')) {
                        // echo( "<!-- " . TEMPLATE_DIR . $file . "/config.php -->\n");
                        include( TEMPLATE_DIR . $file . '/config.php');
                        if (isset( $chat_model) and (TEMPLATE_VERSION <= $chat_model['CUR_TEMPLATE_VERSION'])) {
                            echo( "<option value=\"$file\"");
                            if ($file == TEMPLATE) echo( " selected");
                            echo( ">" . $chat_model['CUR_TEMPLATE_NAME'] . "</option>\n");
                        }
                    }
                }
            }
            closedir($dh);
        } else {
            echo( "<option value=\"\">Dossier '" . TEMPLATE_DIR . "' non trouv&eacute; !</option>\n");
        }

?>
        </select></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td colspan="2">Vous pouvez changer de mod&egrave;le de design &agrave; tout moment en relancant l'installation de Chaton</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3"><strong>Qu'allez-vous utiliser comme base de donn&eacute;es
        d'utilisateurs ?</strong></td>
      <td>&nbsp;</td>
    </tr>
    <?php
        // Dtermination des modules installs
        $chat_ext = NULL;
        if ($dh = @opendir( 'inc/ext/')) {
            while (($file = readdir($dh)) !== false) {
                if ($file{0} != '.') {
                    if (eregi('.php-orig$', $file)) {
                        $fileinfo = pathinfo($file);
                        $fileinfo['basename'] = substr($fileinfo["basename"],0,strlen($fileinfo["basename"]) - (strlen($fileinfo["extension"]) + 1) );
                        if ($fileinfo['basename'] != 'demo') {
                            $chat_ext[] = strtoupper( $fileinfo['basename']);
                            if (ereg( 'define\([ ]*"MODULE_EXT_DESCR",([^\)]*)\);', file_get_contents( 'inc/ext/' . $file), $results)) {
                                $chat_descr[strtoupper( $fileinfo['basename'])] = trim( strtr($results[1], "'\"", "  "));
                            }
                        }
                    }
                }
            }
            closedir($dh);
        }
        // Protection...
        if (!is_array($chat_ext) or (count($chat_ext) == 0)) {
            if (defined("BASE_UTILISATEURS_EXTERNE") and (BASE_UTILISATEURS_EXTERNE == true)) {
                $force_mode_interne = true;
            }
        }
    ?>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td colspan="2"><input name="base_user" type="radio" value="base_user"<?php if (!defined("BASE_UTILISATEURS_EXTERNE") or (BASE_UTILISATEURS_EXTERNE == false) or isset($force_mode_interne)) echo( " checked"); ?>>
        La base initiale (Chaton fonctionnera en autonome) - <strong>Recommand&eacute;</strong></td>
      <td>&nbsp;</td>
    </tr>
    <?php
        foreach( $chat_ext as $extension) {
            // Cas particulier pour SPIP
            if ($extension == 'SPIP') {
                ?>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td colspan="2"><input type="radio" name="base_user" value="SPIP"<?php if ((defined("SPIP_UTILISATEURS") and (SPIP_UTILISATEURS == true)) or (defined("MODULE_UTILISATEURS_EXTERNE") and (strcasecmp(MODULE_UTILISATEURS_EXTERNE,'spip')==0))) echo( " checked"); ?>>
        La base d'utilisateurs de SPIP<?php if (isset($chat_descr[$extension])) echo( " - " . $chat_descr[$extension]);?></td>
      <td>&nbsp;</td>
    </tr>
                <?php
            } else {
                ?>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td colspan="2"><input type="radio" name="base_user" value="<?php echo( $extension); ?>"<?php if (defined("MODULE_UTILISATEURS_EXTERNE") and (strcasecmp(MODULE_UTILISATEURS_EXTERNE,$extension)==0)) echo( " checked"); ?>>
        La base d'utilisateurs de <?php echo( $extension); if (isset($chat_descr[$extension])) echo( " - " . $chat_descr[$extension]);?></td>
      <td>&nbsp;</td>
    </tr>
                <?php
            }
        }
        if (is_array($chat_ext) and (count($chat_ext) > 0)) {
    ?>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">Si vous ne savez pas ce que c'est, laissez l'option &quot;base
        initiale&quot; coch&eacute;e par d&eacute;faut.</td>
      <td>&nbsp;</td>
    </tr>
    <?php
        }
    ?>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3"><strong>Configuration g&eacute;n&eacute;rale :</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Nom du service de discussion :</td>
      <td><input name="nom_chat" type="text" id="nom_chat" value="<?php if (defined("NOM_CHAT")) echo( NOM_CHAT); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>URL de base (o&ugrave; est install&eacute; chaton) :</td>
      <td><input name="url_serveur" type="text" id="url_serveur" value="<?php
            if (defined("URL_SERVEUR") and (URL_SERVEUR != '')) {
                echo( URL_SERVEUR);
            } else {
                echo( 'http://' . $_SERVER['SERVER_NAME'] . dirname( $_SERVER['SCRIPT_NAME']) . '/' );
            }
            ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Email du webmestre :</td>
      <td><input name="email" type="text" id="email" value="<?php if (defined("EMAIL_ADMINISTRATEUR")) echo( EMAIL_ADMINISTRATEUR); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Envoyer un email au webmestre lors de la connexion d'un utilisateur
        ? </td>
      <td><input name="envoi_email" type="checkbox" value="true"<?php if ((defined("ENVOI_EMAIL_CONNEXION")) and (ENVOI_EMAIL_CONNEXION == true)) echo( " checked"); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>D&eacute;tecter et afficher les hyperliens dans les messages ?</td>
      <td><input name="detection_hyperliens" type="checkbox" value="true"<?php if ((defined("DETECTION_HYPERLIENS")) and (DETECTION_HYPERLIENS == true)) echo( " checked"); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Les utilisateurs doivent-ils s'enregistrer pour rentrer dans le chat
        ?</td>
      <td><input name="enregistrement_obligatoire" type="checkbox" value="true"<?php if ((defined("ENREGISTREMENT_OBLIGATOIRE")) and (ENREGISTREMENT_OBLIGATOIRE == true)) echo( " checked"); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Utiliser plusieurs salles de discussion ?</td>
      <td><input name="autoriser_plusieurs_salons" type="checkbox" value="true"<?php if ((defined("AUTORISER_PLUSIEURS_SALONS")) and (AUTORISER_PLUSIEURS_SALONS == true)) echo( " checked"); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>Autoriser les utilisateurs &agrave; cr&eacute;er des salons priv&eacute;s
        et &agrave; pouvoir les administrer ?</td>
      <td><input name="autoriser_salons_prives" type="checkbox" value="true"<?php if ((defined("AUTORISER_SALONS_PRIVES")) and (AUTORISER_SALONS_PRIVES == true)) echo( " checked"); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3"><strong>Liste des salons publics par d&eacute;faut si vous
        d&eacute;sirez plusieurs salles de discussion :</strong> (vous pouvez
        en avoir autant que vous voulez)</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon1" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon1" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon2" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon2" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon3" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon3" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon4" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon4" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon5" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon5" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon6" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon6" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon7" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon7" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon8" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon8" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon9" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon9" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <?php list($nom_court, $nom_complet) = each( $salon_public); ?>
      <td align="right">Salon
        <input name="salon10" type="text" size="20" maxlength="20"<?php if( isset($nom_court)) echo( " value=\"$nom_court\""); ?>>
        , nom complet :</td>
      <td><input name="nom_salon10" type="text" size="30" maxlength="30"<?php if( isset($nom_complet)) echo( " value=\"$nom_complet\""); ?>></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="3" align="right"><hr> <input type="submit" value="suivant &gt;&gt;">
      </td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
    } elseif ($etape == 2) {
        if (isset($_POST["base_user"])) {
            $base_user = $_POST["base_user"];
        } else {
            $base_user = "base_user";
        }
        if (isset($_POST["nom_chat"])) $nom_chat = htmlentities( strip_tags( StripSlashes( $_POST["nom_chat"])));
        if (isset($_POST["url_serveur"])) $url_serveur = strip_tags( StripSlashes( $_POST["url_serveur"]));
        if (isset($_POST["modele"])) $modele = strip_tags( StripSlashes( $_POST["modele"]));
        if (isset($_POST["email"])) $email = htmlentities( strip_tags( $_POST["email"]));
        if (isset($_POST["envoi_email"])) $envoi_email = $_POST["envoi_email"];
        if (!isset($envoi_email) or ($envoi_email != 'true')) $envoi_email = 'false';

        if (isset($_POST["detection_hyperliens"])) $detection_hyperliens = $_POST["detection_hyperliens"];
        if (!isset($detection_hyperliens) or ($detection_hyperliens != 'true')) $detection_hyperliens = 'false';

        if (isset($_POST["autoriser_plusieurs_salons"])) $autoriser_plusieurs_salons = $_POST["autoriser_plusieurs_salons"];
        if (!isset($autoriser_plusieurs_salons) or ($autoriser_plusieurs_salons != 'true')) $autoriser_plusieurs_salons = 'false';

        if (isset($_POST["autoriser_salons_prives"])) $autoriser_salons_prives = $_POST["autoriser_salons_prives"];
        if (!isset($autoriser_salons_prives) or ($autoriser_salons_prives != 'true')) $autoriser_salons_prives = 'false';

        if (isset($_POST["enregistrement_obligatoire"])) $enregistrement_obligatoire = $_POST["enregistrement_obligatoire"];
        if (!isset($enregistrement_obligatoire) or ($enregistrement_obligatoire != 'true')) $enregistrement_obligatoire = 'false';

        if (isset($_POST["salon1"])) $salon1 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon1"]))));
        if (isset($_POST["salon2"])) $salon2 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon2"]))));
        if (isset($_POST["salon3"])) $salon3 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon3"]))));
        if (isset($_POST["salon4"])) $salon4 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon4"]))));
        if (isset($_POST["salon5"])) $salon5 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon5"]))));
        if (isset($_POST["salon6"])) $salon6 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon6"]))));
        if (isset($_POST["salon7"])) $salon7 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon7"]))));
        if (isset($_POST["salon8"])) $salon8 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon8"]))));
        if (isset($_POST["salon9"])) $salon9 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon9"]))));
        if (isset($_POST["salon10"])) $salon10 = strtolower( htmlentities( strip_tags( StripSlashes( $_POST["salon10"]))));
        if (isset($_POST["nom_salon1"])) $nom_salon1 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon1"])));
        if (isset($_POST["nom_salon2"])) $nom_salon2 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon2"])));
        if (isset($_POST["nom_salon3"])) $nom_salon3 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon3"])));
        if (isset($_POST["nom_salon4"])) $nom_salon4 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon4"])));
        if (isset($_POST["nom_salon5"])) $nom_salon5 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon5"])));
        if (isset($_POST["nom_salon6"])) $nom_salon6 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon6"])));
        if (isset($_POST["nom_salon7"])) $nom_salon7 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon7"])));
        if (isset($_POST["nom_salon8"])) $nom_salon8 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon8"])));
        if (isset($_POST["nom_salon9"])) $nom_salon9 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon9"])));
        if (isset($_POST["nom_salon10"])) $nom_salon10 = htmlentities( strip_tags( StripSlashes( $_POST["nom_salon10"])));

        $message_retour = "";

        // Ecriture du fichier de config
        $fichier_source = fopen( './inc/chat.php-orig', 'r');
        if ($fichier_source) {
            $buffer = fread( $fichier_source, filesize( './inc/chat.php-orig'));
            if ($base_user == 'base_user') {
                $buffer = ereg_replace( 'define\( "BASE_UTILISATEURS_EXTERNE",[^\)]*\);', 'define( "BASE_UTILISATEURS_EXTERNE", false);', $buffer);
            } else {
                $buffer = ereg_replace( 'define\( "BASE_UTILISATEURS_EXTERNE",[^\)]*\);', 'define( "BASE_UTILISATEURS_EXTERNE", true);', $buffer);
                $buffer = ereg_replace( 'define\( "MODULE_UTILISATEURS_EXTERNE",[^\)]*\);', 'define( "MODULE_UTILISATEURS_EXTERNE", "' . $base_user . '");', $buffer);
            }
            $buffer = ereg_replace( 'define\( "NOM_CHAT",[^\)]*\);', 'define( "NOM_CHAT", "' . $nom_chat . '");', $buffer);
            $buffer = ereg_replace( 'define\( "URL_SERVEUR",[^\)]*\);', 'define( "URL_SERVEUR", "' . $url_serveur . '");', $buffer);
            $buffer = ereg_replace( 'define\( "TEMPLATE",[^\)]*\);', 'define( "TEMPLATE", "' . $modele . '");', $buffer);
            $buffer = ereg_replace( 'define\( "EMAIL_ADMINISTRATEUR",[^\)]*\);', 'define( "EMAIL_ADMINISTRATEUR", "' . $email . '");', $buffer);
            $buffer = ereg_replace( 'define\( "ENVOI_EMAIL_CONNEXION",[^\)]*\);', 'define( "ENVOI_EMAIL_CONNEXION", ' . $envoi_email . ');', $buffer);
            $buffer = ereg_replace( 'define\( "DETECTION_HYPERLIENS",[^\)]*\);', 'define( "DETECTION_HYPERLIENS", ' . $detection_hyperliens . ');', $buffer);
            $buffer = ereg_replace( 'define\( "ENREGISTREMENT_OBLIGATOIRE",[^\)]*\);', 'define( "ENREGISTREMENT_OBLIGATOIRE", ' . $enregistrement_obligatoire . ');', $buffer);
            $buffer = ereg_replace( 'define\( "AUTORISER_PLUSIEURS_SALONS",[^\)]*\);', 'define( "AUTORISER_PLUSIEURS_SALONS", ' . $autoriser_plusieurs_salons . ');', $buffer);
            $buffer = ereg_replace( 'define\( "AUTORISER_SALONS_PRIVES",[^\)]*\);', 'define( "AUTORISER_SALONS_PRIVES", ' . $autoriser_salons_prives . ');', $buffer);

            // Autres paramtres dj dfinis mais non repris dans la config
            if (defined("TEMPLATE_DIR")) $buffer = ereg_replace( 'define\( "TEMPLATE_DIR",[^\)]*\);', 'define( "TEMPLATE_DIR", "' . TEMPLATE_DIR . '");', $buffer);
            if (defined("MOT_BIENVENUE")) $buffer = ereg_replace( 'define\( "MOT_BIENVENUE",[^\)]*\);', 'define( "MOT_BIENVENUE", "' . MOT_BIENVENUE . '");', $buffer);
            if (defined("MAX_SALON")) $buffer = ereg_replace( 'define\( "MAX_SALON",[^\)]*\);', 'define( "MAX_SALON", "' . MAX_SALON . '");', $buffer);
            if (defined("MAX_TAILLE_MESSAGE")) $buffer = ereg_replace( 'define\( "MAX_TAILLE_MESSAGE",[^\)]*\);', 'define( "MAX_TAILLE_MESSAGE", "' . MAX_TAILLE_MESSAGE . '");', $buffer);
            if (defined("MAX_IMAGE_WIDTH")) $buffer = ereg_replace( 'define\( "MAX_IMAGE_WIDTH",[^\)]*\);', 'define( "MAX_IMAGE_WIDTH", "' . MAX_IMAGE_WIDTH . '");', $buffer);
            if (defined("MAX_IMAGE_HEIGHT")) $buffer = ereg_replace( 'define\( "MAX_IMAGE_HEIGHT",[^\)]*\);', 'define( "MAX_IMAGE_HEIGHT", "' . MAX_IMAGE_HEIGHT . '");', $buffer);
            if (defined("USER_APPEL")) $buffer = ereg_replace( 'define\( "USER_APPEL",[^\)]*\);', 'define( "USER_APPEL", "' . USER_APPEL . '");', $buffer);
            if (defined("ICONES_HUMEUR")) {
                if (ICONES_HUMEUR) {
                    $icones_humeur = "true";
                } else {
                    $icones_humeur = "false";
                }
                $buffer = ereg_replace( 'define\( "ICONES_HUMEUR",[^\)]*\);', 'define( "ICONES_HUMEUR", ' . $icones_humeur . ');', $buffer);
            }
            if (defined("ARCHIVER_DISCUSSIONS")) {
                if (ARCHIVER_DISCUSSIONS) {
                    $archiver_discussion = "true";
                } else {
                    $archiver_discussion = "false";
                }
                $buffer = ereg_replace( 'define\( "ARCHIVER_DISCUSSIONS",[^\)]*\);', 'define( "ARCHIVER_DISCUSSIONS", ' . $archiver_discussion . ');', $buffer);
            }
            if (defined("TEMPS_INACTIVITE")) $buffer = ereg_replace( 'define\( "TEMPS_INACTIVITE",[^\)]*\);', 'define( "TEMPS_INACTIVITE", ' . TEMPS_INACTIVITE . ');', $buffer);

            if (defined("AFFICHER_SALLES_VIDES")) {
                if (AFFICHER_SALLES_VIDES) {
                    $afficher_salles_vides = "true";
                } else {
                    $afficher_salles_vides = "false";
                }
                $buffer = ereg_replace( 'define\( "AFFICHER_SALLES_VIDES",[^\)]*\);', 'define( "AFFICHER_SALLES_VIDES", ' . $afficher_salles_vides . ');', $buffer);
            }

            if (defined("MULTILANGUE")) {
                if (MULTILANGUE) {
                    $multilangue = "true";
                } else {
                    $multilangue = "false";
                }
                $buffer = ereg_replace( 'define\( "MULTILANGUE",[^\)]*\);', 'define( "MULTILANGUE", ' . $multilangue . ');', $buffer);
            }
            if (defined("LANGUE_PAR_DEFAUT")) {
                // Mise  jour v1.0 -> v1.1
                if (LANGUE_PAR_DEFAUT === 0) $langue_par_defaut = 'en';
                elseif (LANGUE_PAR_DEFAUT === 1) $langue_par_defaut = 'fr';
                elseif (LANGUE_PAR_DEFAUT === 2) $langue_par_defaut = 'fr-perso';
                else $langue_par_defaut = LANGUE_PAR_DEFAUT;
                $buffer = ereg_replace( 'define\( "LANGUE_PAR_DEFAUT",[^\)]*\);', 'define( "LANGUE_PAR_DEFAUT", \'' . $langue_par_defaut . '\');', $buffer);
            }
            if (defined("CLE_CHIFFRAGE")) $buffer = ereg_replace( 'define\( "CLE_CHIFFRAGE",[^\)]*\);', 'define( "CLE_CHIFFRAGE", \'' . CLE_CHIFFRAGE . '\');', $buffer);
            if (defined("MOT_DE_PASSE_ADMIN")) $buffer = ereg_replace( 'define\( "MOT_DE_PASSE_ADMIN",[^\)]*\);', 'define( "MOT_DE_PASSE_ADMIN", \'' . MOT_DE_PASSE_ADMIN . '\');', $buffer);
            if (defined("PASS_MYSQL")) $buffer = ereg_replace( 'define\( "PASS_MYSQL",[^\)]*\);', 'define( "PASS_MYSQL", \'' . PASS_MYSQL . '\');', $buffer);
            if (defined("PREFIXE_TABLES")) $buffer = ereg_replace( 'define\( "PREFIXE_TABLES",[^\)]*\);', 'define( "PREFIXE_TABLES", "' . PREFIXE_TABLES . '");', $buffer);

            if (defined("CENSURER")) {
                if (CENSURER) {
                    $censurer = "true";
                } else {
                    $censurer = "false";
                }
                $buffer = ereg_replace( 'define\( "CENSURER",[^\)]*\);', 'define( "CENSURER", ' . $censurer . ');', $buffer);
            }

            if (defined("ANTI_FLOODING")) {
                if (ANTI_FLOODING) {
                    $anti_flooding = "true";
                } else {
                    $anti_flooding = "false";
                }
                $buffer = ereg_replace( 'define\( "ANTI_FLOODING",[^\)]*\);', 'define( "ANTI_FLOODING", ' . $anti_flooding . ');', $buffer);
            }

            if (defined("DETECTION_IMAGES")) {
                if (DETECTION_IMAGES) {
                    $detection_images = "true";
                } else {
                    $detection_images = "false";
                }
                $buffer = ereg_replace( 'define\( "DETECTION_IMAGES",[^\)]*\);', 'define( "DETECTION_IMAGES", ' . $detection_images . ');', $buffer);
            }

            if (defined("AUTORISER_COULEURS_ANONYME")) {
                if (AUTORISER_COULEURS_ANONYME) {
                    $autoriser_couleurs_anonyme = "true";
                } else {
                    $autoriser_couleurs_anonyme = "false";
                }
                $buffer = ereg_replace( 'define\( "AUTORISER_COULEURS_ANONYME",[^\)]*\);', 'define( "AUTORISER_COULEURS_ANONYME", ' . $autoriser_couleurs_anonyme . ');', $buffer);
            }

            if (defined("AUTORISER_IMAGES_ANONYME")) {
                if (AUTORISER_IMAGES_ANONYME) {
                    $autoriser_images_anonyme = "true";
                } else {
                    $autoriser_images_anonyme = "false";
                }
                $buffer = ereg_replace( 'define\( "AUTORISER_IMAGES_ANONYME",[^\)]*\);', 'define( "AUTORISER_IMAGES_ANONYME", ' . $autoriser_images_anonyme . ');', $buffer);
            }

            if ($taux_rafraichissement) $buffer = ereg_replace( '\$taux_rafraichissement = [0-9]+;', '$taux_rafraichissement = ' . $taux_rafraichissement . ';', $buffer);

            $chaine_salon = "\n";
            if ( (isset($salon1)) and (isset($nom_salon1)) and ($salon1) and ($nom_salon1) ) $chaine_salon .= "        \"$salon1\" => \"$nom_salon1\",\n";
            if ( (isset($salon2)) and (isset($nom_salon2)) and ($salon2) and ($nom_salon2) ) $chaine_salon .= "        \"$salon2\" => \"$nom_salon2\",\n";
            if ( (isset($salon3)) and (isset($nom_salon3)) and ($salon3) and ($nom_salon3) ) $chaine_salon .= "        \"$salon3\" => \"$nom_salon3\",\n";
            if ( (isset($salon4)) and (isset($nom_salon4)) and ($salon4) and ($nom_salon4) ) $chaine_salon .= "        \"$salon4\" => \"$nom_salon4\",\n";
            if ( (isset($salon5)) and (isset($nom_salon5)) and ($salon5) and ($nom_salon5) ) $chaine_salon .= "        \"$salon5\" => \"$nom_salon5\",\n";
            if ( (isset($salon6)) and (isset($nom_salon6)) and ($salon6) and ($nom_salon6) ) $chaine_salon .= "        \"$salon6\" => \"$nom_salon6\",\n";
            if ( (isset($salon7)) and (isset($nom_salon7)) and ($salon7) and ($nom_salon7) ) $chaine_salon .= "        \"$salon7\" => \"$nom_salon7\",\n";
            if ( (isset($salon8)) and (isset($nom_salon8)) and ($salon8) and ($nom_salon8) ) $chaine_salon .= "        \"$salon8\" => \"$nom_salon8\",\n";
            if ( (isset($salon9)) and (isset($nom_salon9)) and ($salon9) and ($nom_salon9) ) $chaine_salon .= "        \"$salon9\" => \"$nom_salon9\",\n";
            if ( (isset($salon10)) and (isset($nom_salon10)) and ($salon10) and ($nom_salon10) ) $chaine_salon .= "        \"$salon10\" => \"$nom_salon10\",\n";

            $buffer = ereg_replace( '\$salon_public = array \( // Debut tableau salons publics.*\); // Fin tableau salons publics',
                                    '$salon_public = array ( // Debut tableau salons publics' . $chaine_salon . '    ); // Fin tableau salons publics', $buffer);

            $buffer = ereg_replace( '\$url_erreur = "[^"]*";', '$url_erreur = "' . $url_erreur . '";', $buffer);
            $buffer = ereg_replace( '\$url_sortie = "[^"]*";', '$url_sortie = "' . $url_sortie . '";', $buffer);

            // Fichier de sortie
            $fichier_sortie = @fopen( './inc/chat.php', 'w');
            if ($fichier_sortie) {
                if (fwrite( $fichier_sortie, $buffer)) {
                    $toutok = true;
                } else {
                    $message_retour .= "Ecriture du fichier de configuration ... <b>Erreur !</b><br>\n";
                    $toutok = false;
                }
                fclose( $fichier_sortie);
            } else {
                $message_retour .= "Ecriture du fichier de configuration ... <b>Erreur !</b><br>\n";
                $toutok = false;
            }
            fclose( $fichier_source);
        } else {
            $message_retour .= "Ouverture du fichier de configuration ... <b>Erreur !</b><br>\n";
            $toutok = false;
        }

        // Prparation du mot de passe non affichable
        $chat_database_pass_affichable = '';
        if (defined( 'CHAT_DATABASE_PASS')) {
            $chat_database_pass_affichable = str_pad( $chat_database_pass_affichable, strlen( CHAT_DATABASE_PASS));
        }
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="3">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2" align="center"><strong>Script d'installation ou de mise
        &agrave; jour de Chaton (Etape 2)</strong>
        <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <?php if ($toutok == false) { ?>
    <tr>
      <td>&nbsp;</td>
      <td><?php echo( $message_retour); ?></td>
      <td>&nbsp;</td>
    </tr>
    <?php } else { ?>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2"><strong>Configuration de la base de donn&eacute;es personnelle
        de Chaton :</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">Ceci est la base qui contiendra les discussions (obligatoire mme si vous utilisez une base externe type SPIP ou autre)</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Serveur MySQL :</td>
      <td><input name="chat_host" type="text" id="chat_host" value="<?php echo( CHAT_DATABASE_HOST); ?>" size="50"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Nom de la base MySQL</td>
      <td><input name="chat_name" type="text" id="chat_name" value="<?php echo( CHAT_DATABASE_NAME); ?>" size="50"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Utilisateur MySQL :</td>
      <td><input name="chat_user" type="text" id="chat_user" value="<?php echo( CHAT_DATABASE_USER); ?>" size="50"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Mot de passe MySQL :</td>
      <td><input name="chat_pass" type="password" id="chat_pass" value="<?php echo( $chat_database_pass_affichable); ?>" size="50"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2" align="right"><hr>
        <input type="submit" value="suivant &gt;&gt;">
      </td>
      <td>&nbsp;</td>
    </tr>
    <?php } ?>
  </table>
</form>
<?php
    } elseif ($etape == 3) {
        if (isset($_POST["chat_host"])) $chat_host = $_POST["chat_host"];
        if (isset($_POST["chat_name"])) $chat_name = $_POST["chat_name"];
        if (isset($_POST["chat_user"])) $chat_user = $_POST["chat_user"];
        if (isset($_POST["chat_pass"])) $chat_pass = $_POST["chat_pass"];

        // Mot de passe vide ?
        if ( (Trim( $chat_pass) == '') and (defined( 'CHAT_DATABASE_PASS')) ) $chat_pass = CHAT_DATABASE_PASS;

        // 1- Test de la connexion au serveur MySQL
        $message_retour = "";
        $chat_base = @mysql_connect( $chat_host, $chat_user, $chat_pass);
        if ($chat_base) {
            $message_retour .= "Connexion au serveur MySQL ... <b>OK</b><br>\n";
            if ( @mysql_select_db( $chat_name, $chat_base)) {
                $message_retour .= "Connexion &agrave; la base de donnes ... <b>OK</b><br>\n";

                $requete = @mysql_list_tables( $chat_name, $chat_base);
                if ($requete) {
                    $message_retour .= "R&eacute;cup&eacute;ration de la liste des tables ... <b>OK</b> :<br>\n";
                    $toutok = true;
                    while ($row = mysql_fetch_row($requete)) {
                       $message_retour .= "&nbsp;&nbsp;&nbsp; $row[0]<br>\n";
                    }
                } else {
                    $message_retour .= "R&eacute;cup&eacute;ration de la liste des tables ... <b>Erreur !</b><br>\n";
                    $toutok = false;
                }

            } else {
                $message_retour .= "Connexion &agrave; la base de donnes ... <b>Erreur !</b><br>\n";
                $toutok = false;
            }
        } else {
            $message_retour .= "Connexion au serveur MySQL ... <b>Erreur !</b> (" . mysql_error() . ")<br>\n";
            $toutok = false;
        }

        // 2- Ecriture des fichiers de config
        if ($toutok == true) {
            $fichier_source = fopen( './inc/database.php-orig', 'r');
            if ($fichier_source) {
                $buffer = fread( $fichier_source, filesize( './inc/database.php-orig'));
                $buffer = ereg_replace( 'define\( "CHAT_DATABASE_HOST",[^\)]*\);', 'define( "CHAT_DATABASE_HOST", \'' . $chat_host . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "CHAT_DATABASE_NAME",[^\)]*\);', 'define( "CHAT_DATABASE_NAME", \'' . $chat_name . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "CHAT_DATABASE_USER",[^\)]*\);', 'define( "CHAT_DATABASE_USER", \'' . $chat_user . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "CHAT_DATABASE_PASS",[^\)]*\);', 'define( "CHAT_DATABASE_PASS", \'' . $chat_pass . '\');', $buffer);

                // Fichier de sortie
                $fichier_sortie = fopen( './inc/database.php', 'w');
                if (fwrite( $fichier_sortie, $buffer)) {
                    $message_retour .= "Ecriture du fichier de configuration ... <b>OK</b><br>\n";
                    $toutok = true;
                } else {
                    $message_retour .= "Ecriture du fichier de configuration ... <b>Erreur !</b><br>\n";
                    $toutok = false;
                }
                fclose( $fichier_sortie);
            } else {
                $message_retour .= "Ouverture du fichier de configuration ... <b>Erreur !</b><br>\n";
                $toutok = false;
            }
            fclose( $fichier_source);
        }
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="4">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="center"><strong>Script d'installation ou de mise &agrave; jour
        de Chaton (Etape 3)</strong>
        <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><?php echo( $message_retour); ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>L'installation automatis&eacute;e va maintenant tenter de cr&eacute;er
        ou mettre &agrave; jour les bases de donn&eacute;es utilis&eacute;es par
        Chaton.<br> <strong>Note</strong>: Si
        les tables existent d&eacute;j&agrave;, elles ne seront <strong>pas</strong>
        &eacute;cras&eacute;es ! </td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="right"><hr>
        <?php if ($toutok == true) { ?>
        <input type="submit" value="suivant &gt;&gt;">
        <?php } else { ?>
        <a href="JavaScript:history.go(-1)">&lt; &lt; pr&eacute;c&eacute;dent</a>
        <?php } ?>
      </td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
    } elseif ($etape == 4) {
        $message_retour = "";
        chat_open();

        if ($chat_base) {
            $requete = @mysql_query(
"CREATE TABLE `" . $table_ban_pseudo . "` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `pseudo` varchar(50) NOT NULL default '',
  `debut` datetime default NULL,
  `fin` datetime default NULL,
  `qui` varchar(50) NOT NULL default '',
  `last_ip` varchar(15) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `pseudo` (`pseudo`)
) AUTO_INCREMENT=1", $chat_base);
            if ($requete) {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_ban_pseudo</i> ... <b>OK</b><br>\n";
            } else {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_ban_pseudo</i> ... <b>non effectu&eacute; (existe d&eacute;j&agrave;)</b><br>\n";
            }

            $requete = @mysql_query(
"CREATE TABLE `" . $table_journal . "` (
  `texte` text,
  `ip` text,
  `nav` text,
  `date` datetime default NULL
) ", $chat_base);
            if ($requete) {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_journal</i> ... <b>OK</b><br>\n";
            } else {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_journal</i> ... <b>non effectu&eacute; (existe d&eacute;j&agrave;)</b><br>\n";
            }

            $requete = @mysql_query(
"CREATE TABLE `" . $table_salle . "` (
  `id` int(10) unsigned NOT NULL default '0',
  `nom` varchar(50) NOT NULL default '',
  `createur` int(10) unsigned NOT NULL default '0',
  `proprio` int(10) unsigned NOT NULL default '0',
  `cnx` timestamp(14) NOT NULL,
  `nombre` smallint(6) NOT NULL default '0',
  `prive` tinyint(3) unsigned NOT NULL default '0',
  `mdp` varchar(50) NOT NULL default '',
  `max` smallint(5) unsigned default NULL,
  `permanent` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `nom` (`nom`),
  KEY `permanent` (`permanent`),
  KEY `prive` (`prive`)
) ", $chat_base);
            if ($requete) {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_salle</i> ... <b>OK</b><br>\n";
            } else {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_salle</i> ... <b>non effectu&eacute; (existe d&eacute;j&agrave;)</b><br>\n";
            }

            $requete = @mysql_query(
"CREATE TABLE `" . $table_utilisateur . "` (
  `id` int(10) unsigned NOT NULL default '0',
  `cookie` varchar(50) NOT NULL default '',
  `login` varchar(50) NOT NULL default '',
  `hide` tinyint(3) unsigned NOT NULL default '0',
  `sid` int(10) unsigned NOT NULL default '0',
  `salon` varchar(50) NOT NULL default '',
  `numero` int(10) unsigned NOT NULL default '0',
  `priv` tinyint(3) unsigned NOT NULL default '0',
  `defilement` tinyint(3) unsigned NOT NULL default '1',
  `mode_user` tinyint(3) unsigned NOT NULL default '0',
  `proprietaire` int(10) unsigned NOT NULL default '0',
  `cnx` datetime default NULL,
  `enr` datetime default NULL,
  `ip` varchar(15) NOT NULL default '',
  `robot` tinyint(3) unsigned NOT NULL default '0',
  `parent` int(10) unsigned NOT NULL default '0',
  `deconnexion` tinyint(3) unsigned NOT NULL default '0',
  `oqp` varchar(255) default NULL,
  `ignorer` varchar(255) default NULL,
  `etat` tinyint(3) unsigned NOT NULL default '1',
  `lang` varchar(10) default NULL,
  PRIMARY KEY  (`id`),
  KEY `cookie` (`cookie`),
  KEY `deconnexion` (`deconnexion`),
  KEY `parent` (`parent`),
  KEY `robot` (`robot`),
  KEY `sid` (`sid`),
  KEY `hide` (`hide`),
  KEY `login` (`login`)
) ", $chat_base);
            if ($requete) {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_utilisateur</i> ... <b>OK</b><br>\n";
            } else {
                $message_retour .= "Cr&eacute;ation de la table <i>$table_utilisateur</i> ... <b>non effectu&eacute; (existe d&eacute;j&agrave;)</b><br>\n";
            }

            if ((!defined("BASE_UTILISATEURS_EXTERNE")) or (BASE_UTILISATEURS_EXTERNE == false)) {
                $requete = @mysql_query(
"CREATE TABLE `$table_base_utilisateur` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `login` varchar(30) NOT NULL default '',
  `mdp` varchar(30) NOT NULL default '',
  `nom` text,
  `prenom` text,
  `email` text,
  `bio` text NOT NULL,
  `nom_site` text NOT NULL,
  `url_site` text NOT NULL,
  `priv` smallint(5) unsigned NOT NULL default '0',
  `sexe` tinyint(4) default NULL,
  `naissance` date default NULL,
  `creation` date default NULL,
  `nb_cnx_chat` int(10) unsigned default '0',
  `date_cnx` date default NULL,
  `last_ip` varchar(15) default NULL,
  `last_browser` text,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `login` (`login`)
) ", $chat_base);
                if ($requete) {
                    $message_retour .= "Cr&eacute;ation de la table <i>$table_base_utilisateur</i> ... <b>OK</b><br>\n";
                    // Utilisateur administrateur - A ne creer que la premire fois !
                    $requete = @mysql_query( "INSERT INTO `$table_base_utilisateur` VALUES (1, 'admin', 'admin', 'Administrateur', '', '', '', '', '', 10, 0, NULL, now(), 0, '0000-00-00', '0.0.0.0', 'none')", $chat_base);
                    if ($requete) {
                        $message_retour .= "Cr&eacute;ation d'un utilisateur administrateur login=<b>admin</b> mot de passe=<b>admin</b> ... <b>OK</b><br>\n";
                    } else {
                        $message_retour .= "Cr&eacute;ation d'un utilisateur administrateur ... <b>non effectu&eacute;</b><br>\n";
                    }
                } else {
                    $message_retour .= "Cr&eacute;ation de la table <i>$table_base_utilisateur</i> ... <b>non effectu&eacute; (existe d&eacute;j&agrave;)</b><br>\n";
                }
            }

            // Test mise  jour 0.9.5 utile ?
            $maj_095 = true;
            $requete_maj = @mysql_query( "SHOW KEYS FROM `$table_utilisateur`", $chat_base);
            if ($requete_maj) {
                while ($row = mysql_fetch_array($requete_maj)) {
                    if ($row['Column_name'] == 'login') $maj_095 = false;
                } // end while
            }
            if ($maj_095) {
                @mysql_query( "ALTER TABLE `$table_utilisateur` CHANGE `cnx` `cnx` DATETIME DEFAULT NULL", $chat_base);
                @mysql_query( "ALTER TABLE `$table_utilisateur` CHANGE `enr` `enr` DATETIME DEFAULT NULL", $chat_base);
                @mysql_query( "ALTER TABLE `$table_utilisateur` ADD INDEX ( `login` )", $chat_base);
                @mysql_query( "ALTER TABLE `$table_salle` CHANGE `max` `max` SMALLINT( 5 ) UNSIGNED", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.5 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.5 ... <b>non effectu&eacute;</b><br>\n";
            }

            if ((!defined("BASE_UTILISATEURS_EXTERNE")) or (BASE_UTILISATEURS_EXTERNE == false)) {
                // Test mise  jour 0.9.9a utile ?
                $maj_099a = true;
                $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_base_utilisateur` LIKE 'bio'", $chat_base);
                if ($requete_maj) {
                    if (mysql_num_rows( $requete_maj) == 1) $maj_099a = false;
                }

                if ($maj_099a) {
                    @mysql_query( "ALTER TABLE `$table_base_utilisateur` ADD `bio` TEXT NOT NULL AFTER `email` ,
ADD `nom_site` TEXT NOT NULL AFTER `bio` ,
ADD `url_site` TEXT NOT NULL AFTER `nom_site` ", $chat_base);
                    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.9a ... <b>OK</b><br>\n";
                //} else {
                //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.9a ... <b>non effectu&eacute;</b><br>\n";
                }
            }

            // Test mise  jour 0.9.9c utile ?
            $maj_099c = true;
            $requete_maj = @mysql_query( "SHOW KEYS FROM `$table_salle`", $chat_base);
            if ($requete_maj) {
                while ($row = mysql_fetch_array($requete_maj)) {
                    if ($row['Column_name'] == 'nom') $maj_099c = false;
                } // end while
            }
            if ($maj_099c) {
                @mysql_query( "ALTER TABLE `$table_salle` ADD UNIQUE ( `nom` )", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.9c ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.9c ... <b>non effectu&eacute;</b><br>\n";
            }

            if ((!defined("BASE_UTILISATEURS_EXTERNE")) or (BASE_UTILISATEURS_EXTERNE == false)) {
                // Test mise  jour 0.9.9d utile ?
                $maj_099d = true;
                $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_base_utilisateur` LIKE 'creation'", $chat_base);
                if ($requete_maj) {
                    if (mysql_num_rows( $requete_maj) == 1) $maj_099d = false;
                }

                if ($maj_099d) {
                    @mysql_query( "ALTER TABLE `$table_base_utilisateur` ADD `creation` DATE AFTER `naissance`", $chat_base);
                    @mysql_query( "UPDATE `$table_base_utilisateur` SET creation=now()", $chat_base);
                    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.9d ... <b>OK</b><br>\n";
                //} else {
                //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 0.9.9d ... <b>non effectu&eacute;</b><br>\n";
                }
            }

            // Test mise  jour 1.0.0rc5 utile ?
            $maj_100rc5 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_ban_pseudo` LIKE 'last_ip'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_100rc5 = false;
            }

            if ($maj_100rc5) {
                @mysql_query( "ALTER TABLE `$table_ban_pseudo` ADD `last_ip` VARCHAR( 15 ) NOT NULL", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.0.0rc5 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.0.0rc5 ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.0.2 utile ?
            $maj_102 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_ban_pseudo` LIKE 'last_ip'", $chat_base);
            if ($requete_maj) {
                if ( (mysql_num_rows( $requete_maj) == 1) and (mysql_result( $requete_maj, 0, 'Type') == 'varchar(15)') ) $maj_102 = false;
            }

            if ($maj_102) {
                @mysql_query( "ALTER TABLE `$table_ban_pseudo` CHANGE `last_ip` `last_ip` VARCHAR( 15 ) NOT NULL ", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.0.2 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.0.2 ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.1.0 utile ?
            $maj_110 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_utilisateur` LIKE 'lang'", $chat_base);
            if ($requete_maj) {
                if ( (mysql_num_rows( $requete_maj) == 1) and (mysql_result( $requete_maj, 0, 'Type') == 'varchar(10)') ) $maj_110 = false;
            }

            if ($maj_110) {
                @mysql_query( "ALTER TABLE `$table_utilisateur` CHANGE `lang` `lang` VARCHAR( 10 )", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.1.0 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.1.0 ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.1.0a utile ?
            $maj_110a = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_journal` LIKE 'nav'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_110a = false;
            }

            if ($maj_110a) {
                @mysql_query( "ALTER TABLE `$table_journal` ADD `nav` TEXT AFTER `ip`", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.1.0a ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.1.0a ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.2.2 utile ?
            if ((!defined("BASE_UTILISATEURS_EXTERNE")) or (BASE_UTILISATEURS_EXTERNE == false)) {
                $maj_122 = true;
                $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_base_utilisateur` LIKE 'mdp'", $chat_base);
                if ($requete_maj) {
                    if ( (mysql_num_rows( $requete_maj) == 1) and (mysql_result( $requete_maj, 0, 'Type') == 'varchar(30)') ) $maj_122 = false;
                }

                if ($maj_122) {
                    @mysql_query( "ALTER TABLE `$table_base_utilisateur` CHANGE `login` `login` VARCHAR( 30 ) NOT NULL", $chat_base);
                    @mysql_query( "ALTER TABLE `$table_base_utilisateur` CHANGE `mdp` `mdp` VARCHAR( 30 ) NOT NULL", $chat_base);
                    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.2.2 ... <b>OK</b><br>\n";
                //} else {
                //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.2.2 ... <b>non effectu&eacute;</b><br>\n";
                }
            }

            // Test mise  jour 1.4.3 utile ?
            $maj_143 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_utilisateur` LIKE 'couleur'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_143 = false;
            }

            if ($maj_143) {
                @mysql_query( "ALTER TABLE `$table_utilisateur` ADD `couleur` MEDIUMINT UNSIGNED AFTER `mode_user`", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.4.3 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.4.3 ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.4.4 utile ?
            $maj_144 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_ban_ip`", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) >= 1) $maj_144 = false;
            }
        
            if ($maj_144) {
                @mysql_query(
"CREATE TABLE `$table_ban_ip` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `ip` varchar(15) NOT NULL default '',
  `pseudo` varchar(50) NOT NULL default '',
  `debut` datetime default NULL,
  `fin` datetime default NULL,
  `qui` varchar(50) NOT NULL default '',
  PRIMARY KEY  (`id`),
  KEY `ip` (`ip`)
);", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.4.4 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.4.4 ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.4.5 utile ?
            if ((!defined("BASE_UTILISATEURS_EXTERNE")) or (BASE_UTILISATEURS_EXTERNE == false)) {
                $maj_145 = true;
                $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_base_utilisateur` LIKE 'mdp_encoded'", $chat_base);
                if ($requete_maj) {
                    if (mysql_num_rows( $requete_maj) == 1) $maj_145 = false;
                }
    
                if ($maj_145) {
                    @mysql_query( "ALTER TABLE `$table_base_utilisateur` ADD `mdp_encoded` BLOB AFTER `mdp`", $chat_base);
                    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.4.5 ... <b>OK</b><br>\n";
                //} else {
                //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.4.5 ... <b>non effectu&eacute;</b><br>\n";
                }
            }

            // Test mise  jour 1.5.0 utile ?
            $maj_150 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_meta`", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) >= 1) $maj_150 = false;
            }

            if ($maj_150) {
                @mysql_query(
"CREATE TABLE `$table_meta` (
  `nom` VARCHAR( 255 ) NOT NULL ,
  `valeur` VARCHAR( 255 ) NOT NULL ,
  INDEX ( `nom` ) 
);", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.0 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.0 ... <b>non effectu&eacute;</b><br>\n";
            }

/*
            // Test mise  jour 1.5.1 utile ?
            $maj_151 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_utilisateur` LIKE 'msg'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_151 = false;
            }

            if ($maj_151) {
                @mysql_query( "ALTER TABLE `$table_utilisateur` ADD `msg` DATETIME AFTER `enr`", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.1 ... <b>OK</b><br>\n";
            } else {
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.1 ... <b>non effectu&eacute;</b><br>\n";
            }
*/

            // Test mise  jour 1.5.2 utile ?
            if ((!defined("BASE_UTILISATEURS_EXTERNE")) or (BASE_UTILISATEURS_EXTERNE == false)) {
                $maj_152 = true;
                $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_base_utilisateur` LIKE 'pays'", $chat_base);
                if ($requete_maj) {
                    if (mysql_num_rows( $requete_maj) == 1) $maj_152 = false;
                }
    
                if ($maj_152) {
                    @mysql_query( "ALTER TABLE `$table_base_utilisateur` ADD `pays` TEXT NOT NULL AFTER `email`, ADD `fuseau` TINYINT DEFAULT '0' NOT NULL AFTER `pays`", $chat_base);
                    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.2 ... <b>OK</b><br>\n";
                //} else {
                //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.2 ... <b>non effectu&eacute;</b><br>\n";
                }
            }

            $maj_152bis = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_utilisateur` LIKE 'flags'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_152bis = false;
            }

            if ($maj_152bis) {
                @mysql_query( "ALTER TABLE `$table_utilisateur` ADD `flags` SMALLINT UNSIGNED DEFAULT '0' NOT NULL", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.2b ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.5.2b ... <b>non effectu&eacute;</b><br>\n";
            }

            // Test mise  jour 1.6.1 utile ?
            $maj_161 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_salle` LIKE 'version'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_161 = false;
            }

            if ($maj_161) {
                @mysql_query( "ALTER TABLE `$table_salle` ADD `version` BIGINT UNSIGNED DEFAULT '0' NOT NULL", $chat_base);
                @mysql_query( "ALTER TABLE `$table_utilisateur` ADD `version` BIGINT UNSIGNED DEFAULT '0' NOT NULL", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.6.1 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.6.1 ... <b>non effectu&eacute;</b><br>\n";
            }

            $maj_163 = true;
            $requete_maj = @mysql_query( "SHOW COLUMNS FROM `$table_salle` LIKE 'nb_hide'", $chat_base);
            if ($requete_maj) {
                if (mysql_num_rows( $requete_maj) == 1) $maj_163 = false;
            }

            if ($maj_163) {
                @mysql_query( "ALTER TABLE `$table_salle` ADD `nb_hide` TINYINT NOT NULL DEFAULT '0' AFTER `nombre`", $chat_base);
                $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.6.3 ... <b>OK</b><br>\n";
            //} else {
            //    $message_retour .= "Mise &agrave; jour de la base de donn&eacute;es version 1.6.3 ... <b>non effectu&eacute;</b><br>\n";
            }

            $toutok = true;
        } else {
            $message_retour .= "Ouverture de la base de donn&eacute;es ... <b>Erreur !</b><br>\n";
            $toutok = false;
        }

?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="5">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="center"><strong>Script d'installation ou de mise &agrave; jour
        de Chaton (Etape 4)</strong>
        <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><?php echo( $message_retour); ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="right"><hr>
        <?php if ($toutok == true) { ?>
        <input type="submit" value="suivant &gt;&gt;">
        <?php } ?>
      </td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
        chat_close();
    } elseif (($etape == 5) and (defined("BASE_UTILISATEURS_EXTERNE")) and (BASE_UTILISATEURS_EXTERNE == true)) {
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="6">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2" align="center"><strong>Script d'installation ou de mise
        &agrave; jour de Chaton (Etape 5)</strong> <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2"><strong>Configuration de la base de donn&eacute;es de <?php echo( MODULE_UTILISATEURS_EXTERNE); ?>
        :</strong><br>
        Cette op&eacute;ration ne modifie pas les donn&eacute;es ni les tables
        de <?php echo( MODULE_UTILISATEURS_EXTERNE); ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Serveur MySQL utilis&eacute; par <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> :</td>
      <td><input name="ext_host" type="text" id="ext_host" value="<?php echo( constant( MODULE_UTILISATEURS_EXTERNE . '_DATABASE_HOST')); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Nom de la base MySQL utilis&eacute;e par <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> </td>
      <td><input name="ext_name" type="text" id="ext_name" value="<?php echo( constant( MODULE_UTILISATEURS_EXTERNE . '_DATABASE_NAME')); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Utilisateur MySQL utilis&eacute; par <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> :</td>
      <td><input name="ext_user" type="text" id="ext_user" value="<?php echo( constant( MODULE_UTILISATEURS_EXTERNE . '_DATABASE_USER')); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Mot de passe MySQL utilis&eacute; par <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> :</td>
      <td><input name="ext_pass" type="password" id="ext_pass" value="<?php echo( constant( MODULE_UTILISATEURS_EXTERNE . '_DATABASE_PASS')); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Table des utilisateurs de <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> :</td>
      <td><input name="ext_table" type="text" id="ext_table" value="<?php echo( $table_utilisateurs_extension); ?>" size="20">
        <strong>(*)</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>Dossier o&ugrave; est install&eacute; <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> :<br>
        (si le chemin est relatif, &agrave; partir de la racine de Chaton)<br>
        <br>
        <em>Ce param&egrave;tre n'est utile que si vous souhaitez utiliser les
        sessions de <?php echo( MODULE_UTILISATEURS_EXTERNE); ?> pour authentifier vos utilisateurs.</em></td>
      <td><input name="ext_dossier_racine" type="text" id="ext_dossier_racine" value="<?php if (defined(MODULE_UTILISATEURS_EXTERNE . '_DOSSIER_RACINE')) echo( constant( MODULE_UTILISATEURS_EXTERNE . '_DOSSIER_RACINE')); ?>" size="40"></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">(*) <strong>Ne pas touchez pas &agrave; ce param&egrave;tre
        si vous avez une installation standard de <?php echo( MODULE_UTILISATEURS_EXTERNE); ?>.</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2">&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td colspan="2" align="right"><hr> <input type="submit" value="suivant &gt;&gt;">
      </td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
    } elseif ($etape == 6) {
        $extension = strtolower( MODULE_UTILISATEURS_EXTERNE);
        if (isset($_POST["ext_host"])) $ext_host = $_POST["ext_host"];
        if (isset($_POST["ext_name"])) $ext_name = $_POST["ext_name"];
        if (isset($_POST["ext_user"])) $ext_user = $_POST["ext_user"];
        if (isset($_POST["ext_pass"])) $ext_pass = $_POST["ext_pass"];
        if (isset($_POST["ext_table"])) $ext_table = $_POST["ext_table"];
        if (isset($_POST["ext_dossier_racine"])) $ext_dossier_racine = ValideChemin( $_POST["ext_dossier_racine"]);

        $dossier_test = '';
        // Charge les infos du module choisi
        $fichier_module = file_get_contents( 'inc/ext/' . $extension . '.php');
        if (ereg( 'define\([ ]*"MODULE_EXT_DOSSIER_TEST",([^\)]*)\);', $fichier_module, $results)) {
            $dossier_test = trim( strtr($results[1], "'\"", "  "));
        }

        // 1- Test de la connexion au serveur MySQL
        $message_retour = "";
        $chat_base = @mysql_connect( $ext_host, $ext_user, $ext_pass);
        if ($chat_base) {
            $message_retour .= "Connexion au serveur MySQL ... <b>OK</b><br>\n";
            if ( @mysql_select_db( $ext_name, $chat_base)) {
                $message_retour .= "Connexion &agrave; la base de donnes ... <b>OK</b><br>\n";

                $requete = @mysql_query( "SELECT * FROM $ext_table", $chat_base);
                if ($requete) {
                    $message_retour .= "Acc&egrave;s &agrave; la table des utilisateurs de " . MODULE_UTILISATEURS_EXTERNE . " ... <b>OK</b> :<br>\n";
                    $toutok = true;
                } else {
                    $message_retour .= "Acc&egrave;s &agrave; la table des utilisateurs de " . MODULE_UTILISATEURS_EXTERNE . " ... <b>Erreur !</b><br>\n";
                    $toutok = false;
                }

            } else {
                $message_retour .= "Connexion &agrave; la base de donnes ... <b>Erreur !</b><br>\n";
                $toutok = false;
            }
        } else {
            $message_retour .= "Connexion au serveur MySQL ... <b>Erreur !</b><br>\n";
            $toutok = false;
        }

        // 2- Test du dossier d'installation du module
        if ($dossier_test) {
            if (file_exists( $ext_dossier_racine . $dossier_test)) {
                $message_retour .= "Dossier d'installation de " . MODULE_UTILISATEURS_EXTERNE . " ... <b>OK</b> :<br>\n";
            } else {
                $message_retour .= "Dossier d'installation de " . MODULE_UTILISATEURS_EXTERNE . " ... <b>non trouv&eacute; !</b><br>&nbsp; &nbsp; (vous ne pourrez pas utiliser la reconnaissance automatique de l'utilisateur par session)<br>\n";
            }
        }

        // 3- Ecriture des fichiers de config
        if ($toutok == true) {
            $fichier_source = fopen( "./inc/ext/$extension.php-orig", 'r');
            if ($fichier_source) {
                $buffer = fread( $fichier_source, filesize( "./inc/ext/$extension.php-orig"));
                $buffer = ereg_replace( 'define\( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_HOST",[^\)]*\);', 'define( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_HOST", \'' . $ext_host . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_NAME",[^\)]*\);', 'define( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_NAME", \'' . $ext_name . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_USER",[^\)]*\);', 'define( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_USER", \'' . $ext_user . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_PASS",[^\)]*\);', 'define( "' . MODULE_UTILISATEURS_EXTERNE . '_DATABASE_PASS", \'' . $ext_pass . '\');', $buffer);
                $buffer = ereg_replace( 'define\( "' . MODULE_UTILISATEURS_EXTERNE . '_DOSSIER_RACINE",[^\)]*\);', 'define( "' . MODULE_UTILISATEURS_EXTERNE . '_DOSSIER_RACINE", \'' . $ext_dossier_racine . '\');', $buffer);
                $buffer = ereg_replace( '\$table_utilisateurs_extension = \'[^\']*\';', "\$table_utilisateurs_extension = '$ext_table';", $buffer);

                // Fichier de sortie
                $fichier_sortie = @fopen( "./inc/ext/$extension.php", 'w');
                if ($fichier_sortie) {
                    if (fwrite( $fichier_sortie, $buffer)) {
                        $message_retour .= "Ecriture du fichier de configuration $extension ... <b>OK</b><br>\n";
                        $toutok = true;
                    } else {
                        $message_retour .= "Ecriture du fichier de configuration $extension ... <b>Erreur !</b><br>\n";
                        $toutok = false;
                    }
                    fclose( $fichier_sortie);
                } else {
                    $message_retour .= "Ecriture du fichier de configuration $extension ... <b>Erreur !</b><br>\n";
                    $toutok = false;
                }
            } else {
                $message_retour .= "Ouverture du fichier de configuration $extension ... <b>Erreur !</b><br>\n";
                $toutok = false;
            }
            fclose( $fichier_source);
        }
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <input name="etape" type="hidden" id="etape" value="7">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="center"><strong>Script d'installation ou de mise &agrave; jour
        de Chaton (Etape 6)</strong>
        <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><?php echo( $message_retour); ?></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="right"><hr>
        <?php if ($toutok == true) { ?>
        <input type="submit" value="suivant &gt;&gt;">
        <?php } else { ?>
        <a href="JavaScript:history.go(-1)">&lt; &lt; pr&eacute;c&eacute;dent</a>
        <?php } ?>
      </td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
    } elseif (($etape == 5) or ($etape == 7)) {
        // Termin !
?>
<form action="<?php echo( $_SERVER['SCRIPT_NAME']); ?>" method="post" name="formulaire" id="formulaire">
  <table width="600" border="0" align="center" cellpadding="2" cellspacing="2" bgcolor="#EEEEEE">
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="center"><strong>Script d'installation ou de mise &agrave; jour
        de Chaton (Termin&eacute;)</strong> <hr></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><strong>L'installation ou la mise &agrave; jour de Chaton v<?php echo( VERSION_MISE_A_JOUR); ?> est maintenant
        termin&eacute;e !</strong></td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td><strong><font color="red">Important</font> :</strong><br>
        Pour des raisons de s&eacute;curit&eacute;, effacez, d&eacute;placez ou renommez le script <strong><?php echo( $_SERVER['SCRIPT_NAME']); ?></strong>
        !</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
      <td>&nbsp;</td>
    </tr>
    <tr>
      <td>&nbsp;</td>
      <td align="right"><hr> <a href="index.php">Entrer dans le chat &gt;&gt;</a></td>
      <td>&nbsp;</td>
    </tr>
  </table>
</form>
<?php
    } else {
        echo( "Erreur");
    }
?>
</body>
</html>
